# Contributing to MicroShift

Welcome to MicroShift! We are glad you are interested in this project. 
If you’d like to jump right in with MicroShift then check out the [open issues](https://github.com/redhat-et/microshift/issues), pull requests are always welcome. 

## Documentation

Looking for the docs? Well, look no further; [microshift.io](https://microshift.io) has the answers. 
If you would like to contribute to the documentation pages, check out the [documentation repo](https://github.com/redhat-et/microshift-documentation).


## Issues

Notice a bug? File an issue [here](https://github.com/redhat-et/microshift/issues/new/choose) and provide as much information as possible.

## Enhancement Proposals

MicroShift’s goal is to create a minimal core that can functionally operate as close to OpenShift as 
possible while maintaining a low resource impact. We are always looking for enhancement proposals, 
so feel free to create an enhancement issue with a link to a document that explains your proposal. 
The enhancement will be considered as long as it aligns with [MicroShift's design goals](https://github.com/redhat-et/microshift/blob/main/docs/design/design.md).

## Community

Join us on [Slack](https://microshift.slack.com)! ([Invite to the Slack space](https://join.slack.com/t/microshift/shared_invite/zt-uxncbjbl-XOjueb1ShNP7xfByDxNaaA))

Community meetings are held weekly, Wednesdays at 10:30AM - 11:00AM EST. Be sure to join the community [calendar](https://calendar.google.com/calendar/embed?src=nj6l882mfe4d2g9nr1h7avgrcs%40group.calendar.google.com&ctz=America%2FChicago)! Click "Google Calendar" in the lower right-hand corner to subscribe.

